#include <stdio.h>
#include "compress.h"



TWO_BYTES buffer_data=0;
int buffer_location=0;


int bit_buffer_read(int bits) {
        int retval;
        if (bits>buffer_location) bits=buffer_location;

        retval=(buffer_data>>((sizeof(buffer_data)*8)-bits));
        buffer_data=(buffer_data<<bits);
        buffer_location-=bits;
        return(retval);
}

void bit_buffer_write(unsigned int val, unsigned int bits) {
        if ((bits+buffer_location)>(sizeof(buffer_data)*8)) {
                printf("bit_buffer_write: Buffer overflow\n");
                return;
        }
        if ((val>>bits)!=0) {
                printf("bit_buffer_write: Value (%i) is bigger than %i bits.\n",val,bits);
                return;
        }
        buffer_location+=bits;
        buffer_data+=(val<<((sizeof(buffer_data)*8)-buffer_location));
        return;
}

int bit_buffer_size(void) {
        return(buffer_location);
}

void bit_buffer_purge(void) {
        buffer_location=0;
        buffer_data=0;
        return;
}


